// Uso de interrupo externa INT0 provocada por botes (PORTB) e uso de LEDs (PORTD)
  // para  sinalizar a ocorrncia do evento


//INT0 -> RB0
//LEDs -> RD0
void ConfigMCU();

void INTERRUPCAO_HIGH() iv 0x0008 ics ICS_AUTO {

// tratamento - acionar LED
  if(INTCON.INT0IF == 1)
   {
     PORTD.RD0 ^= 1;   //Inverte o estado lgico do PINO
     INTCON.INT0IF = 0;     //  zera flag
   }
}       // Fim do atendimento  interrupo

void ConfigMCU()
{
#ifdef P18F45K22
 ANSELB = 0;
 ANSELD = 0;
 INTCON2.RBPU = 0; //Lembrando que que RBPU  barrado, portanto, acionado em 0
                   //ligar os resistores de pull-up do PORTB
                   //Para o PIC18F45K22, RBPU se comporta como uma chave geral p/ os
                   //resistores de pull up, pois WPUB  responsvel pelo controle
                   //individual do resistor de pull-up de cada pino.
 WPUB.WPUB0 = 1 ;  //ligar o resistor de pull-up no pino RB0

#else    // outro modelo de PIC18F  ?
 ADCON1 |= 0X0F;
 INTCON2.RBPU = 0; //RBPU  barrado!
                   //ligar os resistores de pull-up do PORTB
#endif

 TRISD = 0;  // definir o pino como sada (LED)
 PORTD = 0;  // LEDs inicialmente apagados

}

void main() {
  ConfigMCU();

  //****************************************************************************
  //Configurao Global das interrupes
  INTCON.GIEH = 1;     // Alta prioridade       ex.: INT1
  INTCON.GIEL = 1;     // Baixa prioridade     (INT0)
  RCON.IPEN = 1;       //nveis de prioridade
        // Neste caso, porm, s vamos usar a INT0, portanto, a alta prioridade
        // ser nela. Entretanto, o IP no existe para a INT0 em caso de outras
        // interrup. externas acontecendo ao mesmo tempo, no teria como ela
        // ser de alta prioridade

  //****************************************************************************
  //Configurao da interrupo individual do perifrico - INT0  IE, IF

  // IP no existe para INT0 (alta prioridade)

  //INT0IF/INT0IE - ver datasheet    = INT0 + IF   ou + IE

  INTCON.INT0IF = 0;    //Flag responsvel em gerar/acionar a interrupo
             //IP = 1;  //Alta prioridade de interrupo ( apenas INT1, INT2 etc)
                        //OBS: somente para INT0 NO existe esse registrador(IP)
  INTCON.INT0IE = 1;    //Habilita a interrupo INT0

  // Borda: INTEDG0 = INT + EDG0 - borda0 da interrupt. externa
    INTCON2.INTEDG0 = 1;  //1 - > Borda de subida   (ao soltar a tecla)
                        //0 - > Borda de descida  (ao pressionar a tecla)
  TRISB.RB0 = 1;        //Pino RB0/INT0 como entrada
  //****************************************************************************
 while(1);   //segura o processamento

}